image: janlastuvka/gitlab-ci-pipeline-php82

cache:
  key: ${CI_COMMIT_REF_NAME}
  paths:
    - vendor/

stages:
  - build
  - tests
  - code_analysis

build:
  stage: build
  script:
    - 'composer install --no-interaction -q --prefer-dist'

tests:
  stage: tests
  script:
  - composer tests
  artifacts:
    when: always
    reports:
      junit:
        - tests/unit-tests-results.xml
    expire_in: 1 week

phpstan:
  stage: code_analysis
  script:
    - composer phpstan

phpcs:
  stage: code_analysis
  script:
    - composer phpcs

phpcs_tests:
  stage: code_analysis
  script:
    - composer phpcs-tests